Uses DOS,
     DOS_More;

Procedure Help;
   Begin
      WriteLn('Usage : Trans Source Dest TransfTable1 TransfTable2  - Process');
      WriteLn('        Trans /S                                     - Show Transfere Tables');
      WriteLn('        Trans                                        - This Help');
      WriteLn('');
      WriteLn('Note  : Transfer Tables Must Available In "MAD Directory"');
      WriteLn('');
      Halt;
   End;

Procedure Error;
   Begin
      WriteLn('Wrong Parameters');
      WriteLn('');
      Help;
   End;

Procedure Invalid_Error;
   Begin
      WriteLn('Wrong Modules');
      Halt;
   End;

Procedure Init;
   Begin
      WriteLn('');
      WriteLn('============================================================');
      WriteLn('Text File Transfer/Convertor By MAD Software (c) 1996, Sofia');
      WriteLn('============================================================');
      WriteLn('');
      If ParamCount = 0 Then
         Help;
   End;

Procedure Show_Files;
   Var SR : SearchRec;
   Begin
      WriteLn('Directory Of ', Get_MAD_Dir, ' :');
      WriteLn;
      FindFirst(Get_MAD_Dir + '*.TrT', AnyFile - VolumeID - Directory, SR);
      While DosError = 0 Do
         Begin
            WriteLn(SR.Name);
            FindNext(SR);
         End;
      Halt;
   End;

Var Table1,
    Table2 : String;

Procedure Read_Tables;
   Var F : Text;
   Begin
      AsSign(F,Get_MAD_Dir + ParamStr(3) + '.TrT');
      ReSet(F);
      ReadLn(F,Table1);
      Close(F);

      AsSign(F,Get_MAD_Dir + ParamStr(4) + '.TrT');
      ReSet(F);
      ReadLn(F,Table2);
      Close(F);

      If Length(Table1) <> Length(Table2) Then
         Invalid_Error;
   End;

Procedure Transfere;
   Var F1,
       F2 : Text;
       Ch : Char;
   Begin
      Read_Tables;

      AsSign(F1,ParamStr(1));
      ReSet(F1);

      AsSign(F2,ParamStr(2));
      ReWrite(F2);

      While Not EOF(F1) Do
         Begin
            Read(F1,Ch);
            If Pos(Ch,Table1) <> 0 Then
               Ch:=Table2[Pos(Ch,Table1)];
            Write(F2,Ch);
         End;

      Close(F1);
      Close(F2);
   End;

Procedure Process;
   Begin
      If ParamCount = 1 Then
         If (ParamStr(1) = '/S') Or
            (ParamStr(1) = '/s') Or
            (ParamStr(1) = '-S') Or
            (ParamStr(1) = '-s') Then
            Show_Files
         Else
            Error
      Else
         If ParamCount = 4 Then
            Transfere
         Else
            Error;
   End;

Begin
   Init;
   Process;
End.
